//+------------------------------------------------------------------+
//|                                  |
//|                                                                  |
//| MetodMa_0123 - 0 -               SMA     |
//|                1 -      EMA     |
//|                2 -            SMMA    |
//|                3 - -   LWMA    |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 100
#property indicator_buffers 1
#property indicator_color1 LimeGreen

//---- input parameters

extern double Sensitivity = 2.0;

extern int RSI1Length = 2;

extern int Stoch1KPeriod = 22;
extern int Stoch1DPeriod = 5;
extern int Stoch1Slowing = 5;

extern int Stoch3KPeriod = 99;
extern int Stoch3DPeriod = 9;
extern int Stoch3Slowing = 9;

extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "HPRP_2";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Red;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double G_ibuf_200_up[];
double G_ibuf_204_dn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,G_ibuf_204_dn);
   SetIndexBuffer(2,G_ibuf_200_up);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
DelOb();
   return (0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i;

//----
   double i_rsi_1, i_stochastic_1, i_stochastic_2;

int limit=Bars-IndicatorCounted();
for( i=limit;i>=0;i--)
   {
      i_rsi_1 = iRSI(NULL, 0, RSI1Length, 0, i + 1);
     // G_irsi_248 = iRSI(NULL, 0, RSI2.Length, RSI2.Price, i + 1);
     // G_irsi_256 = iRSI(NULL, 0, RSI3.Length, RSI3.Price, i + 1);
      i_stochastic_1 = iStochastic(NULL, 0, Stoch1KPeriod, Stoch1DPeriod, Stoch1Slowing, MODE_SMA, 0, MODE_MAIN, i + 1);
     // G_istochastic_272 = iStochastic(NULL, 0, Stoch2.KPeriod, Stoch2.DPeriod, Stoch2.Slowing, MODE_SMA, 0, MODE_MAIN, i + 1);
      i_stochastic_2 = iStochastic(NULL, 0, Stoch3KPeriod, Stoch3DPeriod, Stoch3Slowing, MODE_SMA, 0, MODE_MAIN, i + 1);
     
      G_ibuf_200_up[i] = MathArctan(i_rsi_1*i_stochastic_1*i_stochastic_2);
      G_ibuf_204_dn[i] = MathArctan((100-i_rsi_1)*(100-i_stochastic_1)*(100-i_stochastic_2));

      //     
      if((G_ibuf_200_up[i+1] - G_ibuf_200_up[i]) >G_ibuf_200_up[i+1]* Sensitivity / 100.0)
         {
          ExtMapBuffer1[i]=-90;
          if(ShowArrows)DrawAr("up",i);
         }
      //     
      else if((G_ibuf_204_dn[i+1] - G_ibuf_204_dn[i]) > G_ibuf_204_dn[i+1]*Sensitivity / 100.0)
         {
          ExtMapBuffer1[i]=90;
          if(ShowArrows)DrawAr("dn",i);
         }

       else 
        {
          ExtMapBuffer1[i]=0;
         }
     }
//----

   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//*****************
void DelOb()
{
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, arrowsIdentifier) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
}

//----------------------------------------------------------------------
void DrawAr(string ssName, int i)
{
    
    string sName=arrowsIdentifier+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    double gap  = 1.5*iATR(NULL,0,20,i)/3.0;
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  228);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-gap);
    ObjectSet(sName, OBJPROP_COLOR, arrowsUpColor);
    }
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  230);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+gap);
    ObjectSet(sName, OBJPROP_COLOR, arrowsDnColor);    
    }    
    ObjectSet(sName, OBJPROP_WIDTH, 1);
}
//**********************************  